
-- Loads the entity system
ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
local id = 0

-- Registers a entity into the system via the register table
function ents.Startup()
	register["enemy"] = love.filesystem.load( ents.objpath .. "enemy.lua" )
end

-- Require a file but not run it. The file you Derive is a 'special' class.
function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )()
end

-- Creates a entity
function ents.Create(name, x, y, BG)--name is de register["name"]
	-- If you don't fill in all parameters then parameters = ...
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end
	
	if not BG then
		BG = false
	end
	-- If you create a entity then if the entity is registered then do:
	if register[name] then
		id = id + 1
		local ent = register[name]()
		ent:load()
		ent.type = name
		ent:setPos(x, y)
		ent.id = id
		ent.BG = BG
		ents.objects[id] = ent
		return ents.objects[id]
		-- If the entity is not registered then print a error.
	else
		print("Error: Entity " .. name .. " does not exist! Snap!")
		return false;
	end
end
-- Remove the entity out of the map
function ents.Destroy( id )
	if ents.objects[id] then
		if ents.objects[id].Die then
			ents.objects[id]:Die()
		end
		ents.objects[id] = nil
	end
end
-- The update function for entities
function ents:update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end
-- The draw function for entities, if the BG == false
function ents:draw()
	for i, ent in pairs(ents.objects) do
		if not ent.BG then
			if ent.draw then
				ent:draw()
			end
		end
	end
end
-- The draw function for entities, if the BG == true
function ents:drawBG()
	for i, ent in pairs(ents.objects) do
		if ent.BG then
			if ent.draw then
				ent:draw()
			end
		end
	end
end
