require("collision")
player = {}

function player_load()
-- The properties of the player
	player.x = 5
	player.y = 5
	player.xvel = 0
	player.yvel = 0
	player.friction = 7
	player.speed = 500
	player.mass = 1.7 --the weight of the player
	player.jumpheight = -300 --must be negative
	
	player_standL = love.graphics.newImage("/res/mannetje2.png")
	player_standR = love.graphics.newImage("/res/mannetje.png")
	player_right = love.graphics.newImage("/res/mannetjevoetr.png")
	player_left = love.graphics.newImage("/res/mannetjevoetl.png")
	player.image = player_standR
	player.width = player.image:getWidth()
	player.height = player.image:getHeight()
	
end

function player_physics(dt)
-- The physics that affect the player
	-- Movement
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	-- Sliding
	player.xvel = player.xvel * (1 - math.min(dt * player.friction, 1))
	-- Gravity
	if player.y + player.image:getHeight() < screenheight then
		player.yvel = player.yvel + gravity * player.mass * dt
	end
	-- Collision detection
	print(checkcollision(0,488,32,32,player.x,player.y,player.width,player.height))
	
	
end
	
function player_standstill(key)
	if key == "right" then 
	player.image = player_standR
	end
	
	if key == "left" then
	player.image = player_standL
	end

end
	
function player_move(dt)
-- The function to control the movement of the player
	if love.keyboard.isDown("right") and player.xvel < player.speed then
		player.xvel = player.xvel + player.speed * dt
		player.image = player_right
	end
	if love.keyboard.isDown("left") and player.xvel < player.speed then
		player.xvel = player.xvel - player.speed * dt
		player.image = player_left
	end
	if player.y + player.image:getHeight()  == screenheight and love.keyboard.isDown("z") then
		player.yvel = player.jumpheight
	end
end

function player_boundry()
-- The player can't go out of the window.
	if player.x + player.width > screenwidth then player.x = screenwidth - player.width; player.xvel = 0 end 
	if player.x < 0 then player.x = 0; player.xvel = 0 end
	if player.y + player.height > screenheight then player.y = screenheight - player.height; player.yvel = 0 end
	if player.y < 0 then player.y = 0; player.yvel = 0 end
	
end

function player_draw()

	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.image, player.x, player.y) 
	
end

-- The functions that are going into the main class: A collection of player functions

function UPDATE_PLAYER(dt)
	player_physics(dt)
	player_move(dt)
	player_boundry()

end

function DRAW_PLAYER()
	player_draw()
end